## libv8 2.0.3

=== SConstruct ===
# Copyright 2008 the V8 project authors. All rights reserved.
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
#     * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#     * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following
#       disclaimer in the documentation and/or other materials provided
#       with the distribution.
#     * Neither the name of Google Inc. nor the names of its
#       contributors may be used to endorse or promote products derived
#       from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import platform
import re
import sys
import os
from os.path import join, dirname, abspath
from types import DictType, StringTypes
root_dir = dirname(File('SConstruct').rfile().abspath)
sys.path.append(join(root_dir, 'tools'))
import js2c, utils


# ANDROID_TOP is the top of the Android checkout, fetched from the environment
# variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
# environment variables to the cross-compiling tools.
ANDROID_TOP = os.environ.get('TOP')
if ANDROID_TOP is None:
  ANDROID_TOP=""

# TODO: Sort these issues out properly but as a temporary solution for gcc 4.4
# on linux we need these compiler flags to avoid crashes in the v8 test suite
# and avoid dtoa.c strict aliasing issues
if os.environ.get('GCC_VERSION') == '44':
    GCC_EXTRA_CCFLAGS = ['-fno-tree-vrp']
    GCC_DTOA_EXTRA_CCFLAGS = ['-fno-strict-aliasing']
else:
    GCC_EXTRA_CCFLAGS = []
    GCC_DTOA_EXTRA_CCFLAGS = []

ANDROID_FLAGS = ['-march=armv5te',
                 '-mtune=xscale',
                 '-msoft-float',
                 '-fpic',
                 '-mthumb-interwork',
                 '-funwind-tables',
                 '-fstack-protector',
                 '-fno-short-enums',
                 '-fmessage-length=0',
                 '-finline-functions',
                 '-fno-inline-functions-called-once',
                 '-fgcse-after-reload',
                 '-frerun-cse-after-loop',
                 '-frename-registers',
                 '-fomit-frame-pointer',
                 '-fno-strict-aliasing',
                 '-finline-limit=64',
                 '-MD']

ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
                    ANDROID_TOP + '/bionic/libc/include',
                    ANDROID_TOP + '/bionic/libstdc++/include',
                    ANDROID_TOP + '/bionic/libc/kernel/common',
                    ANDROID_TOP + '/bionic/libc/kernel/arch-arm',
                    ANDROID_TOP + '/bionic/libm/include',
                    ANDROID_TOP + '/bionic/libm/include/arch/arm',
                    ANDROID_TOP + '/bionic/libthread_db/include',
                    ANDROID_TOP + '/frameworks/base/include',
                    ANDROID_TOP + '/system/core/include']

ANDROID_LINKFLAGS = ['-nostdlib',
                     '-Bdynamic',
                     '-Wl,-T,' + ANDROID_TOP + '/build/core/armelf.x',
                     '-Wl,-dynamic-linker,/system/bin/linker',
                     '-Wl,--gc-sections',
                     '-Wl,-z,nocopyreloc',
                     '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.2.1/lib/gcc/arm-eabi/4.2.1/interwork/libgcc.a',
                     ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];

LIBRARY_FLAGS = {
  'all': {
    'CPPPATH': [join(root_dir, 'src')],
    'regexp:native': {
        'CPPDEFINES': ['V8_NATIVE_REGEXP']
    },
    'mode:debug': {
      'CPPDEFINES': ['V8_ENABLE_CHECKS']
    },
    'profilingsupport:on': {
      'CPPDEFINES':   ['ENABLE_LOGGING_AND_PROFILING'],
    },
    'debuggersupport:on': {
      'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
    }
  },
  'gcc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '-fno-rtti', '-fno-exceptions'],
    },
    'visibility:hidden': {
      # Use visibility=default to disable this.
      'CXXFLAGS':     ['-fvisibility=hidden']
    },
    'mode:debug': {
      'CCFLAGS':      ['-g', '-O0'],
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER', 'DEBUG'],
      'os:android': {
        'CCFLAGS':    ['-mthumb']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['-O3', '-fomit-frame-pointer', '-fdata-sections',
                       '-ffunction-sections'],
      'os:android': {
        'CCFLAGS':    ['-mthumb', '-Os'],
        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
      }
    },
    'os:linux': {
      'CCFLAGS':      ['-ansi'] + GCC_EXTRA_CCFLAGS,
      'library:shared': {
        'CPPDEFINES': ['V8_SHARED'],
        'LIBS': ['pthread']
      }
    },
    'os:macos': {
      'CCFLAGS':      ['-ansi', '-mmacosx-version-min=10.4'],
    },
    'os:freebsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:openbsd': {
      'CPPPATH' : ['/usr/local/include'],
      'LIBPATH' : ['/usr/local/lib'],
      'CCFLAGS':      ['-ansi'],
    },
    'os:win32': {
      'CCFLAGS':      ['-DWIN32'],
      'CXXFLAGS':     ['-DWIN32'],
    },
    'os:android': {
      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
      'CCFLAGS':      ANDROID_FLAGS,
      'WARNINGFLAGS': ['-Wall', '-Wno-unused', '-Werror=return-type',
                       '-Wstrict-aliasing=2'],
      'CPPPATH':      ANDROID_INCLUDES,
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32'],
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM']
    },
    'simulator:arm': {
      'CCFLAGS':      ['-m32'],
      'LINKFLAGS':    ['-m32']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'CCFLAGS':      ['-m64'],
      'LINKFLAGS':    ['-m64'],
    },
    'prof:oprofile': {
      'CPPDEFINES':   ['ENABLE_OPROFILE_AGENT']
    }
  },
  'msvc': {
    'all': {
      'CCFLAGS':      ['$DIALECTFLAGS', '$WARNINGFLAGS'],
      'CXXFLAGS':     ['$CCFLAGS', '/GR-', '/Gy'],
      'CPPDEFINES':   ['WIN32'],
      'LINKFLAGS':    ['/INCREMENTAL:NO', '/NXCOMPAT', '/IGNORE:4221'],
      'CCPDBFLAGS':   ['/Zi']
    },
    'verbose:off': {
      'DIALECTFLAGS': ['/nologo'],
      'ARFLAGS':      ['/NOLOGO']
    },
    'arch:ia32': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_IA32', '_USE_32BIT_TIME_T'],
      'LINKFLAGS':    ['/MACHINE:X86'],
      'ARFLAGS':      ['/MACHINE:X86']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'LINKFLAGS':    ['/MACHINE:X64'],
      'ARFLAGS':      ['/MACHINE:X64']
    },
    'mode:debug': {
      'CCFLAGS':      ['/Od', '/Gm'],
      'CPPDEFINES':   ['_DEBUG', 'ENABLE_DISASSEMBLER', 'DEBUG'],
      'LINKFLAGS':    ['/DEBUG'],
      'msvcrt:static': {
        'CCFLAGS': ['/MTd']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MDd']
      }
    },
    'mode:release': {
      'CCFLAGS':      ['/O2'],
      'LINKFLAGS':    ['/OPT:REF', '/OPT:ICF'],
      'msvcrt:static': {
        'CCFLAGS': ['/MT']
      },
      'msvcrt:shared': {
        'CCFLAGS': ['/MD']
      },
      'msvcltcg:on': {
        'CCFLAGS':      ['/GL'],
        'LINKFLAGS':    ['/LTCG'],
        'ARFLAGS':      ['/LTCG'],
      }
    }
  }
}


V8_EXTRA_FLAGS = {
  'gcc': {
    'all': {
      'WARNINGFLAGS': ['-Wall',
                       '-Werror',
                       '-W',
                       '-Wno-unused-parameter',
                       '-Wnon-virtual-dtor']
    },
    'os:win32': {
      'WARNINGFLAGS': ['-pedantic', '-Wno-long-long']
    },
    'os:linux': {
      'WARNINGFLAGS': ['-pedantic'],
      'library:shared': {
        'soname:on': {
          'LINKFLAGS': ['-Wl,-soname,${SONAME}']
        }
      }
    },
    'os:macos': {
      'WARNINGFLAGS': ['-pedantic']
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  },
  'msvc': {
    'all': {
      'WARNINGFLAGS': ['/WX', '/wd4355', '/wd4800']
    },
    'library:shared': {
      'CPPDEFINES': ['BUILDING_V8_SHARED'],
      'LIBS': ['winmm', 'ws2_32']
    },
    'arch:ia32': {
      'WARNINGFLAGS': ['/W3']
    },
    'arch:x64': {
      'WARNINGFLAGS': ['/W3']
    },
    'arch:arm': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
      # /wd4996 is to silence the warning about sscanf
      # used by the arm simulator.
      'WARNINGFLAGS': ['/wd4996']
    },
    'disassembler:on': {
      'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
    }
  }
}


MKSNAPSHOT_EXTRA_FLAGS = {
  'gcc': {
    'os:linux': {
      'LIBS': ['pthread'],
    },
    'os:macos': {
      'LIBS': ['pthread'],
    },
    'os:freebsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:openbsd': {
      'LIBS': ['execinfo', 'pthread']
    },
    'os:win32': {
      'LIBS': ['winmm', 'ws2_32'],
    },
  },
  'msvc': {
    'all': {
      'CPPDEFINES': ['_HAS_EXCEPTIONS=0'],
      'LIBS': ['winmm', 'ws2_32']
    }
  }
}


DTOA_EXTRA_FLAGS = {
  'gcc': {
    'all': {
      'WARNINGFLAGS': ['-Werror', '-Wno-uninitialized'],
      'CCFLAGS': GCC_DTOA_EXTRA_CCFLAGS
    }
  },
  'msvc': {
    'all': {
      'WARNINGFLAGS': ['/WX', '/wd4018', '/wd4244']
    }
  }
}


CCTEST_EXTRA_FLAGS = {
  'all': {
    'CPPPATH': [join(root_dir, 'src')],
    'LIBS': ['$LIBRARY']
  },
  'gcc': {
    'all': {
      'LIBPATH': [abspath('.')]
    },
    'os:linux': {
      'LIBS':         ['pthread'],
    },
    'os:macos': {
      'LIBS':         ['pthread'],
    },
    'os:freebsd': {
      'LIBS':         ['execinfo', 'pthread']
    },
    'os:openbsd': {
      'LIBS':         ['execinfo', 'pthread']
    },
    'os:win32': {
      'LIBS': ['winmm', 'ws2_32']
    },
    'os:android': {
      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
      'CCFLAGS':      ANDROID_FLAGS,
      'CPPPATH':      ANDROID_INCLUDES,
      'LIBPATH':     [ANDROID_TOP + '/out/target/product/generic/obj/lib'],
      'LINKFLAGS':    ANDROID_LINKFLAGS,
      'LIBS':         ['log', 'c', 'stdc++', 'm'],
      'mode:release': {
        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
      }
    },
  },
  'msvc': {
    'all': {
      'CPPDEFINES': ['_HAS_EXCEPTIONS=0'],
      'LIBS': ['winmm', 'ws2_32']
    },
    'library:shared': {
      'CPPDEFINES': ['USING_V8_SHARED']
    },
    'arch:ia32': {
      'CPPDEFINES': ['V8_TARGET_ARCH_IA32']
    },
    'arch:x64': {
      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
      'LINKFLAGS': ['/STACK:2091752']
    },
  }
}


SAMPLE_FLAGS = {
  'all': {
    'CPPPATH': [join(abspath('.'), 'include')],
    'LIBS': ['$LIBRARY'],
  },
  'gcc': {
    'all': {
      'LIBPATH': ['.'],
      'CCFLAGS': ['-fno-rtti', '-fno-exceptions']
    },
    'os:linux': {

## libv8 2.2.18

=== debian/changelog ===
libv8 (2.2.18-1) unstable; urgency=low

  * New upstream release, followed the procedure of README.source to update. 
  * Drops 0005-constraints-visibility.patch (applied upstream).

 -- Jérémy Lal <kapouer@melix.org>  Thu, 17 Jun 2010 00:06:53 +0200

libv8 (2.2.7-1) unstable; urgency=low

  * New upstream release, followed the procedure of README.source to update
  * debian/patches:
    + 0005-constraints-visibility.patch: export SetResourceConstraints to allow
      chromium to compile cleanly

 -- Antonio Radici <antonio@dyne.org>  Sun, 09 May 2010 21:29:33 +0100

libv8 (2.2.6-1) unstable; urgency=low

  [ Jérémy Lal ]
  * New upstream release, previous procedure followed.
  * Switch to dpkg-source 3.0 (quilt) format.
  * Uses scons.mk from cdbs.

  [ Antonio Radici ]
  * debian/control: added Jérémy to the Uploaders
  * debian/patches: 
    + added mips64 to 0003-platform-detection-x86_64-and-mips.patch

 -- Antonio Radici <antonio@dyne.org>  Sat, 01 May 2010 20:04:11 +0100

libv8 (2.1.10-1) unstable; urgency=low

  * New upstream release
    + debian/rules: SONAME updated
    + debian/control: updated any reference to the old version
    + debian/patches/0001-enable_soname.patch: SONAME updated
    + debian/libv8-$VERSION.install renamed with the new version
  * debian/patches:
    + 0001-enable_soname.patch: slightly modified to use the right SONAME
    + 0004-add-the-install-target.patch: refreshed
  * debian/README.source: added a procedure to update to a new version
    once the correct version is imported

 -- Antonio Radici <antonio@dyne.org>  Sat, 27 Mar 2010 15:12:42 +0000

libv8 (2.1.6-1) unstable; urgency=low

  [ Antonio Radici ]
  * New upstream release
    + package should now build clean with gcc-4.5 (Closes: 565030)
    + debian/rules: SONAME var updated
    + debian/libv8-2.0.3.install edited and renamed to libv8-2.1.6.install
    + debian/control: s/2.0.3/2.1.6/
  * debian/control: Standards-Version bumped to 3.8.4 (no changes required)
  * debian/patches:
    + refreshed all patches
    + x86_64_code.patch: changed to drop any reference to ia64 
      (it does not seem to build there)

  [ Jérémy Lal ]
  * debian/copyright: updated to reflect the missing files/dates
  * debian/patches:
    + new naming scheme which preserves the ordering
    + added mips to the x86_64_code.patch

 -- Antonio Radici <antonio@dyne.org>  Sun, 21 Mar 2010 10:58:49 +0000

libv8 (2.0.3-2) unstable; urgency=low

  * Modified the upstream soname (from libv8-2.0.3.so to libv8.so.2.0.3)
    + restored patches/enable_soname.patch
    + restore the link commands in debian/rules
  * Added a libv8-2.0.3.install so that the package is not empty anymore
    + (Closes: 560433)

 -- Antonio Radici <antonio@dyne.org>  Fri, 11 Dec 2009 20:33:23 +0000

libv8 (2.0.3-1) unstable; urgency=low

  * New upstream release
  * restored jsmin.py, now it is DFSG compliant
    + debian/copyright modified accordingly
    + debian/repack.sh not needed anymore
    + debian/patches: remove-jsmin.patch deleted
  * using the library's SONAME (2.0.3)
    + debian/control: libv8-0 renamed to libv8-2.0.3
    + debian/patches: deleted enable_soname.patch
    + debian/rules: adapted to support the upstream SONAME
    + debian/libv8-0.symbols: removed, we will not maintain the symbols file
  * debian/patches: all patches refreshed against the latest upstream
  * debian/patches/x86_64_code.patch: support for ia64

 -- Antonio Radici <antonio@dyne.org>  Mon, 07 Dec 2009 19:07:51 +0000

libv8 (1.3.11+dfsg-2) unstable; urgency=low

  * debian/patches:
    + armel-build.patch: adding march armv5t to build on armel (Closes: 8636294)
    + x86_64_code.patch: build 64 bit code on x86_64 (Closes: 548467, 550448)
  * debian/watch: excluded '..' from the versions (Closes: 550581)
  * debian/changelog: added DM-Upload-Allowed: yes

 -- Antonio Radici <antonio@dyne.org>  Sun, 11 Oct 2009 13:33:11 +0100

libv8 (1.3.11+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #497701)

 -- Antonio Radici <antonio@dyne.org>  Wed, 16 Sep 2009 23:01:31 +0100

=== debian/control ===
Source: libv8
Priority: extra
Maintainer: Antonio Radici <antonio@dyne.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper (>= 7), pkg-config, scons, cdbs (>= 0.4.73)
Standards-Version: 3.8.4
Section: libs
Homepage: http://code.google.com/p/v8/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv8.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv8.git

Package: libv8-dev
Section: libdevel
Architecture: i386 amd64 armel mips
Depends: libv8-2.2.18 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 Install this package if you wish to develop your own programs using the
 V8 JavaScript Engine

Package: libv8-2.2.18
Architecture: i386 amd64 armel mips
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package includes the dynamic library against which you can link your
 program.

Package: libv8-dbg
Section: debug
Architecture: i386 amd64 armel mips
Depends: libv8-2.2.18 (= ${binary:Version}), ${misc:Depends}
Description: Development symbols for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package provides the debugging symbols for the library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/scons.mk

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE       ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE      ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_ARCH          ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

DEBIAN_NAME		:= $(shell dpkg-parsechangelog | sed -n 's/^Source: *\(.*\)$$/\1/ p')
DEBIAN_VERSION		:= $(shell dpkg-parsechangelog | sed -n 's/^Version: *\(.*\)$$/\1/ p')
DEBIAN_UPSTREAM_VERSION	:= $(shell echo $(DEBIAN_VERSION) | sed 's/^\(.*\)-[^-]*$$/\1/')
DEBIAN_UPSTREAM_BRANCH	:= $(shell echo $(DEBIAN_UPSTREAM_VERSION) | sed 's/^\([^\.]*\.[^.+~]*\).*$$/\1/')
DEBIAN_REVISION		:= $(shell echo $(DEBIAN_VERSION) | sed 's/^.*r\([^-]*\).*/\1/')

SONAME			:= 2.2.18

SRC_DIR			:= $(CURDIR)
DEB_BUILDDIR		:= $(SRC_DIR)

DEB_DH_MAKESHLIBS_ARGS := -- -c4

CXXFLAGS += -fno-strict-aliasing
CFLAGS += -fno-strict-aliasing
export CFLAGS
export CXXFLAGS

DEB_SCONS_OPTIONS          := library=shared soname=on shlibtype=hidden
DEB_SCONS_INSTALL_OPTIONS  := $(DEB_SCONS_OPTIONS) DESTDIR=$(DEB_DESTDIR)

clean::
	#if [ -f src/version.cc~ ] ; then mv src/version.cc~ src/version.cc ; fi
	rm -f tools/*.pyc libv8-${SONAME}.so
	rm -rf obj

common-install-impl::
	cd debian/tmp/usr/lib/ ; \
	mv libv8-${SONAME}*.so libv8.so.${SONAME} ; \
	ln -s -T libv8.so.${SONAME} libv8.so

# Tarball (get-orig-source & get-current-source)
V8_SVN_URL := http://v8.googlecode.com/svn/branches/$(DEBIAN_UPSTREAM_BRANCH)
TMP_DDIR   := $(DEBIAN_NAME)-$(shell echo $$$$)
ifeq (,$(LOCAL_BRANCH))
TMP_DIR    := $(TMP_DDIR)
else
TMP_DIR    := $(LOCAL_BRANCH)
endif

ifneq (,$(DEBIAN_TAG))
get-orig-source: TAG  = $(NULL)
else
get-orig-source: TAG  = -r $(shell svn log --limit 1 $(V8_SVN_URL) | grep ^r | head -1 | sed -e 's/^r\([^ ]*\).*/\1/')
endif
get-orig-source: gos-all

get-current-source: TAG = -r $(DEBIAN_REVISION)
get-current-source: gos-all

gos-all: gos-co gos-pack
gos-co:
ifeq (,$(LOCAL_BRANCH))
	rm -rf $(TMP_DIR)
endif
	@if [ ! -d $(TMP_DIR) ] ; then echo mkdir $(TMP_DIR); mkdir $(TMP_DIR) ; fi
	# Checkout
	@if [ ! -d $(TMP_DIR)/src ] ; then \
	  echo svn co $(V8_SVN_URL) $(TMP_DIR)/src ; \
	  svn co $(V8_SVN_URL) $(TMP_DIR)/src ; \
	else \
	  echo svn update $(TMP_DIR)/src ; \
	  svn update $(TMP_DIR)/src ; \
	fi
ifneq (,$(LOCAL_BRANCH))
	rm -rf $(TMP_DDIR)
	cp -la $(TMP_DIR) $(TMP_DDIR)
endif
	
gos-pack: TMP_DIR  = $(TMP_DDIR)
ifneq (,$(DEBIAN_TAG))
gos-pack: VERSION  = $(shell echo $(DEBIAN_TAG) | cut -d= -f2)
else
gos-pack: REVISION = $(shell cd $(TMP_DIR)/src && svn log --xml --limit 1 | grep -E '^( *revision=|<date>)' | tr -d '\n' | \
	             sed -e 's/.*"\([0-9]*\)".*>\(....\)-\(..\)-\(..\)T.*/\2\3\4r\1/')
gos-pack: VERSION  = $(shell grep -E '^#define (MAJOR|MINOR|BUILD)_(VERSION|NUMBER)' $(TMP_DIR)/src/src/version.cc | awk '{ print $$3 }' | tr '\n' '.' | sed -e 's/\.$$//')~svn$(REVISION)
endif
gos-pack:
	# Pack
	mv $(TMP_DIR)/src $(TMP_DIR)/$(DEBIAN_NAME)-$(VERSION)
	cd $(TMP_DIR) && tar zcf ../$(DEBIAN_NAME)_$(VERSION).orig.tar.gz --exclude=.svn $(DEBIAN_NAME)-$(VERSION)
	rm -rf $(TMP_DIR)
	@echo "# Done (created $(DEBIAN_NAME)_$(VERSION).orig.tar.gz)"
	@ls -l $(DEBIAN_NAME)_$(VERSION).orig.tar.gz

## libv8 2.2.24

=== debian/changelog ===
libv8 (2.2.24-6) unstable; urgency=low

  * CVE-2010-3412 (Closes: #597856)
    Race condition in the console implementation in Google Chrome before
    6.0.472.59 has unspecified impact and attack vectors.

 -- Jérémy Lal <kapouer@melix.org>  Fri, 24 Sep 2010 11:44:57 +0200

libv8 (2.2.24-5) unstable; urgency=low

  * Standards-Version 3.9.1. Nothing had to be changed to comply.
  * Fix chromium-browser: priority optional, depends on libv8 which
    has priority extra. (Closes: #591148)
  * Compile with GCC_VERSION=44.
    With that option, v8 pass all tests, and setting a breakpoint
    in chromium inspector does not crash. (Closes: #584562)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 12 Aug 2010 23:39:43 +0200

libv8 (2.2.24-4) unstable; urgency=low

  * Replace arch: mips with mipsel (on the three packages) 

 -- Jérémy Lal <kapouer@melix.org>  Sun, 25 Jul 2010 09:49:03 +0200

libv8 (2.2.24-3) unstable; urgency=low

  * Replace arch: mips with mipsel, because only little endian is supported. 

 -- Jérémy Lal <kapouer@melix.org>  Sat, 24 Jul 2010 13:43:28 +0200

libv8 (2.2.24-2) unstable; urgency=low

  * Upstream patch : fix for...in loops for strings.
    http://codereview.chromium.org/3037008 

 -- Jérémy Lal <kapouer@melix.org>  Mon, 19 Jul 2010 14:55:22 +0200

libv8 (2.2.24-1) unstable; urgency=low

  * New upstream release, followed the procedure of README.source to update.
  * Standards-Version 3.9.0
  * Build for armv4 instead of armv5, fix ARMV5 detection. (Closes: #589057)
  * Include v8-profiler.h in libv8-dev. (Closes: #589584)

 -- Jérémy Lal <kapouer@melix.org>  Wed, 14 Jul 2010 18:56:09 +0200

=== debian/control ===
Source: libv8
Priority: optional
Maintainer: Antonio Radici <antonio@dyne.org>
Uploaders: Jérémy Lal <kapouer@melix.org>
Build-Depends: debhelper (>= 7), pkg-config, scons, cdbs (>= 0.4.73)
Standards-Version: 3.9.1
Section: libs
Homepage: http://code.google.com/p/v8/
DM-Upload-Allowed: yes
Vcs-Browser: http://git.debian.org/?p=collab-maint/libv8.git
Vcs-Git: git://git.debian.org/git/collab-maint/libv8.git

Package: libv8-dev
Section: libdevel
Architecture: i386 amd64 armel mipsel
Depends: libv8-2.2.24 (= ${binary:Version}), ${misc:Depends}
Description: Development files for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 Install this package if you wish to develop your own programs using the
 V8 JavaScript Engine

Package: libv8-2.2.24
Architecture: i386 amd64 armel mipsel
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package includes the dynamic library against which you can link your
 program.

Package: libv8-dbg
Priority: extra
Section: debug
Architecture: i386 amd64 armel mipsel
Depends: libv8-2.2.24 (= ${binary:Version}), ${misc:Depends}
Description: Development symbols for the V8 JavaScript Engine
 V8 is Google's open source, high performance JavaScript engine. It is written
 in C++ and is used in Google Chrome, Google's open source browser.
 .
 This package provides the debugging symbols for the library.

=== debian/rules ===
--- 
+++ 
@@ -15,7 +15,7 @@
 DEBIAN_UPSTREAM_BRANCH	:= $(shell echo $(DEBIAN_UPSTREAM_VERSION) | sed 's/^\([^\.]*\.[^.+~]*\).*$$/\1/')
 DEBIAN_REVISION		:= $(shell echo $(DEBIAN_VERSION) | sed 's/^.*r\([^-]*\).*/\1/')
 
-SONAME			:= 2.2.18
+SONAME			:= 2.2.24
 
 SRC_DIR			:= $(CURDIR)
 DEB_BUILDDIR		:= $(SRC_DIR)
@@ -26,6 +26,8 @@
 CFLAGS += -fno-strict-aliasing
 export CFLAGS
 export CXXFLAGS
+# this is needed to avoid buggy behavior when compiled with gcc 44
+export GCC_VERSION=44
 
 DEB_SCONS_OPTIONS          := library=shared soname=on shlibtype=hidden
 DEB_SCONS_INSTALL_OPTIONS  := $(DEB_SCONS_OPTIONS) DESTDIR=$(DEB_DESTDIR)

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

# unfortunately there is no way we can download from an
# SVN tag but the watch file will still useful to find
# new versions
opts="dversionmangle=s/\+dfsg//" \
http://v8.googlecode.com/svn/tags/ ([^.][\d.]+)/

## libv8 2.5.9.9

=== SConstruct ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright 2008 the V8 project authors. All rights reserved.
+# Copyright 2010 the V8 project authors. All rights reserved.
 # Redistribution and use in source and binary forms, with or without
 # modification, are permitted provided that the following conditions are
 # met:
@@ -35,7 +35,6 @@
 sys.path.append(join(root_dir, 'tools'))
 import js2c, utils
 
-
 # ANDROID_TOP is the top of the Android checkout, fetched from the environment
 # variable 'TOP'.   You will also need to set the CXX, CC, AR and RANLIB
 # environment variables to the cross-compiling tools.
@@ -43,19 +42,25 @@
 if ANDROID_TOP is None:
   ANDROID_TOP=""
 
-# TODO: Sort these issues out properly but as a temporary solution for gcc 4.4
-# on linux we need these compiler flags to avoid crashes in the v8 test suite
-# and avoid dtoa.c strict aliasing issues
-if os.environ.get('GCC_VERSION') == '44':
-    GCC_EXTRA_CCFLAGS = ['-fno-tree-vrp']
-    GCC_DTOA_EXTRA_CCFLAGS = ['-fno-strict-aliasing']
+# ARM_TARGET_LIB is the path to the dynamic library to use on the target
+# machine if cross-compiling to an arm machine. You will also need to set
+# the additional cross-compiling environment variables to the cross compiler.
+ARM_TARGET_LIB = os.environ.get('ARM_TARGET_LIB')
+if ARM_TARGET_LIB:
+  ARM_LINK_FLAGS = ['-Wl,-rpath=' + ARM_TARGET_LIB + '/lib:' +
+                     ARM_TARGET_LIB + '/usr/lib',
+                    '-Wl,--dynamic-linker=' + ARM_TARGET_LIB +
+                    '/lib/ld-linux.so.3']
 else:
-    GCC_EXTRA_CCFLAGS = []
-    GCC_DTOA_EXTRA_CCFLAGS = []
-
-ANDROID_FLAGS = ['-march=armv5te',
-                 '-mtune=xscale',
-                 '-msoft-float',
+  ARM_LINK_FLAGS = []
+
+GCC_EXTRA_CCFLAGS = []
+GCC_DTOA_EXTRA_CCFLAGS = []
+
+ANDROID_FLAGS = ['-march=armv7-a',
+                 '-mtune=cortex-a8',
+                 '-mfloat-abi=softfp',
+                 '-mfpu=vfp',
                  '-fpic',
                  '-mthumb-interwork',
                  '-funwind-tables',
@@ -68,8 +73,10 @@
                  '-frerun-cse-after-loop',
                  '-frename-registers',
                  '-fomit-frame-pointer',
-                 '-fno-strict-aliasing',
                  '-finline-limit=64',
+                 '-DCAN_USE_VFP_INSTRUCTIONS=1',
+                 '-DCAN_USE_ARMV7_INSTRUCTIONS=1',
+                 '-DCAN_USE_UNALIGNED_ACCESSES=1',
                  '-MD']
 
 ANDROID_INCLUDES = [ANDROID_TOP + '/bionic/libc/arch-arm/include',
@@ -91,20 +98,26 @@
                      '-Wl,-z,nocopyreloc',
                      '-Wl,-rpath-link=' + ANDROID_TOP + '/out/target/product/generic/obj/lib',
                      ANDROID_TOP + '/out/target/product/generic/obj/lib/crtbegin_dynamic.o',
-                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.2.1/lib/gcc/arm-eabi/4.2.1/interwork/libgcc.a',
+                     ANDROID_TOP + '/prebuilt/linux-x86/toolchain/arm-eabi-4.4.0/lib/gcc/arm-eabi/4.4.0/interwork/libgcc.a',
                      ANDROID_TOP + '/out/target/product/generic/obj/lib/crtend_android.o'];
 
 LIBRARY_FLAGS = {
   'all': {
     'CPPPATH': [join(root_dir, 'src')],
-    'regexp:native': {
-        'CPPDEFINES': ['V8_NATIVE_REGEXP']
+    'regexp:interpreted': {
+      'CPPDEFINES': ['V8_INTERPRETED_REGEXP']
     },
     'mode:debug': {
       'CPPDEFINES': ['V8_ENABLE_CHECKS']
     },
+    'vmstate:on': {
+      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING'],
+    },
+    'protectheap:on': {
+      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_HEAP_PROTECTION'],
+    },
     'profilingsupport:on': {
-      'CPPDEFINES':   ['ENABLE_LOGGING_AND_PROFILING'],
+      'CPPDEFINES':   ['ENABLE_VMSTATE_TRACKING', 'ENABLE_LOGGING_AND_PROFILING'],
     },
     'debuggersupport:on': {
       'CPPDEFINES':   ['ENABLE_DEBUGGER_SUPPORT'],
@@ -143,6 +156,9 @@
     },
     'os:macos': {
       'CCFLAGS':      ['-ansi', '-mmacosx-version-min=10.4'],
+      'library:shared': {
+        'CPPDEFINES': ['V8_SHARED']
+      }
     },
     'os:freebsd': {
       'CPPPATH' : ['/usr/local/include'],
@@ -150,6 +166,14 @@
       'CCFLAGS':      ['-ansi'],
     },
     'os:openbsd': {
+      'CPPPATH' : ['/usr/local/include'],
+      'LIBPATH' : ['/usr/local/lib'],
+      'CCFLAGS':      ['-ansi'],
+    },
+    'os:solaris': {
+      # On Solaris, to get isinf, INFINITY, fpclassify and other macros one
+      # needs to define __C99FEATURES__.
+      'CPPDEFINES': ['__C99FEATURES__'],
       'CPPPATH' : ['/usr/local/include'],
       'LIBPATH' : ['/usr/local/lib'],
       'CCFLAGS':      ['-ansi'],
@@ -172,11 +196,28 @@
       'LINKFLAGS':    ['-m32']
     },
     'arch:arm': {
-      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM']
+      'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
+      'unalignedaccesses:on' : {
+        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=1']
+      },
+      'unalignedaccesses:off' : {
+        'CPPDEFINES' : ['CAN_USE_UNALIGNED_ACCESSES=0']
+      }
     },
     'simulator:arm': {
       'CCFLAGS':      ['-m32'],
-      'LINKFLAGS':    ['-m32']
+      'LINKFLAGS':    ['-m32'],
+    },
+    'arch:mips': {
+      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
+      'simulator:none': {
+        'CCFLAGS':      ['-EL', '-mips32r2', '-Wa,-mips32r2', '-fno-inline'],
+        'LDFLAGS':      ['-EL']
+      }
+    },
+    'simulator:mips': {
+      'CCFLAGS':      ['-m32'],
+      'LINKFLAGS':    ['-m32'],
     },
     'arch:x64': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
@@ -231,8 +272,16 @@
       },
       'msvcltcg:on': {
         'CCFLAGS':      ['/GL'],
-        'LINKFLAGS':    ['/LTCG'],
         'ARFLAGS':      ['/LTCG'],
+        'pgo:off': {
+          'LINKFLAGS':    ['/LTCG'],
+        },
+        'pgo:instrument': {
+          'LINKFLAGS':    ['/LTCG:PGI']
+        },
+        'pgo:optimize': {
+          'LINKFLAGS':    ['/LTCG:PGO']
+        }
       }
     }
   }
@@ -268,17 +317,11 @@
   },
   'msvc': {
     'all': {
-      'WARNINGFLAGS': ['/WX', '/wd4355', '/wd4800']
+      'WARNINGFLAGS': ['/W3', '/WX', '/wd4355', '/wd4800']
     },
     'library:shared': {
       'CPPDEFINES': ['BUILDING_V8_SHARED'],
       'LIBS': ['winmm', 'ws2_32']
-    },
-    'arch:ia32': {
-      'WARNINGFLAGS': ['/W3']
-    },
-    'arch:x64': {
-      'WARNINGFLAGS': ['/W3']
     },
     'arch:arm': {
       'CPPDEFINES':   ['V8_TARGET_ARCH_ARM'],
@@ -286,6 +329,9 @@
       # used by the arm simulator.
       'WARNINGFLAGS': ['/wd4996']
     },
+    'arch:mips': {
+      'CPPDEFINES':   ['V8_TARGET_ARCH_MIPS'],
+    },
     'disassembler:on': {
       'CPPDEFINES':   ['ENABLE_DISASSEMBLER']
     }
@@ -304,6 +350,10 @@
     'os:freebsd': {
       'LIBS': ['execinfo', 'pthread']
     },
+    'os:solaris': {
+      'LIBS': ['m', 'pthread', 'socket', 'nsl', 'rt'],
+      'LINKFLAGS': ['-mt']
+    },
     'os:openbsd': {
       'LIBS': ['execinfo', 'pthread']
     },
@@ -324,81 +374,3 @@
   'gcc': {
     'all': {
       'WARNINGFLAGS': ['-Werror', '-Wno-uninitialized'],
-      'CCFLAGS': GCC_DTOA_EXTRA_CCFLAGS
-    }
-  },
-  'msvc': {
-    'all': {
-      'WARNINGFLAGS': ['/WX', '/wd4018', '/wd4244']
-    }
-  }
-}
-
-
-CCTEST_EXTRA_FLAGS = {
-  'all': {
-    'CPPPATH': [join(root_dir, 'src')],
-    'LIBS': ['$LIBRARY']
-  },
-  'gcc': {
-    'all': {
-      'LIBPATH': [abspath('.')]
-    },
-    'os:linux': {
-      'LIBS':         ['pthread'],
-    },
-    'os:macos': {
-      'LIBS':         ['pthread'],
-    },
-    'os:freebsd': {
-      'LIBS':         ['execinfo', 'pthread']
-    },
-    'os:openbsd': {
-      'LIBS':         ['execinfo', 'pthread']
-    },
-    'os:win32': {
-      'LIBS': ['winmm', 'ws2_32']
-    },
-    'os:android': {
-      'CPPDEFINES':   ['ANDROID', '__ARM_ARCH_5__', '__ARM_ARCH_5T__',
-                       '__ARM_ARCH_5E__', '__ARM_ARCH_5TE__'],
-      'CCFLAGS':      ANDROID_FLAGS,
-      'CPPPATH':      ANDROID_INCLUDES,
-      'LIBPATH':     [ANDROID_TOP + '/out/target/product/generic/obj/lib'],
-      'LINKFLAGS':    ANDROID_LINKFLAGS,
-      'LIBS':         ['log', 'c', 'stdc++', 'm'],
-      'mode:release': {
-        'CPPDEFINES': ['SK_RELEASE', 'NDEBUG']
-      }
-    },
-  },
-  'msvc': {
-    'all': {
-      'CPPDEFINES': ['_HAS_EXCEPTIONS=0'],
-      'LIBS': ['winmm', 'ws2_32']
-    },
-    'library:shared': {
-      'CPPDEFINES': ['USING_V8_SHARED']
-    },
-    'arch:ia32': {
-      'CPPDEFINES': ['V8_TARGET_ARCH_IA32']
-    },
-    'arch:x64': {
-      'CPPDEFINES':   ['V8_TARGET_ARCH_X64'],
-      'LINKFLAGS': ['/STACK:2091752']
-    },
-  }
-}
-
-
-SAMPLE_FLAGS = {
-  'all': {
-    'CPPPATH': [join(abspath('.'), 'include')],
-    'LIBS': ['$LIBRARY'],
-  },
-  'gcc': {
-    'all': {
-      'LIBPATH': ['.'],
-      'CCFLAGS': ['-fno-rtti', '-fno-exceptions']
-    },
-    'os:linux': {

=== debian/changelog ===
libv8 (2.5.9.9-2) unstable; urgency=low

  * Include v8stdint.h in libv8-dev. 

 -- Jérémy Lal <kapouer@melix.org>  Thu, 20 Jan 2011 23:26:46 +0100

libv8 (2.5.9.9-1) unstable; urgency=low

  * New upstream release.
    followed the procedure of README.source to update.
  * Fix FTBFS on armel. (Closes: #599713)
  * No longer flag march=armv4t, it's the default debian armel target.
    (Closes: #596997)
  * Fix typo in libv8-dbg short description. (Closes: #601855)

 -- Jérémy Lal <kapouer@melix.org>  Thu, 06 Jan 2011 18:02:20 +0100

libv8 (2.4.7-2) experimental; urgency=low

  * Fix FTBFS on armel with -Wno-psabi. For more info :
    http://gcc.gnu.org/bugzilla/show_bug.cgi?id=42748
  * Fix FTBFS on mipsel, just remove it, it is not supported upstream,
    and anyway it won't compile in the 2.2 or 2.3 branches.
  * Respect policy 4.9.1 for DEB_BUILD_OPTIONS nocheck and parallel.
  * Remove unused code from debian/rules.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 09 Oct 2010 21:26:14 +0200

libv8 (2.4.7-1) experimental; urgency=low

  * New upstream release, followed the procedure of README.source to update.
  * Removed patch issue3037008_6001.diff, applied upstream.
  * Removed part of 0002-armel-build.patch, applied upstream.
  * Target for amd64 is x64, not ia32.
  * Remove GCC_VERSION=44, no longer needed.
  * Runs cctest and mjsunit tests after build.

 -- Jérémy Lal <kapouer@melix.org>  Sat, 02 Oct 2010 12:01:53 +0200

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
 
 Package: libv8-dev
 Section: libdevel
-Architecture: i386 amd64 armel mipsel
-Depends: libv8-2.2.24 (= ${binary:Version}), ${misc:Depends}
+Architecture: i386 amd64 armel
+Depends: libv8-2.5.9.9 (= ${binary:Version}), ${misc:Depends}
 Description: Development files for the V8 JavaScript Engine
  V8 is Google's open source, high performance JavaScript engine. It is written
  in C++ and is used in Google Chrome, Google's open source browser.
@@ -21,8 +21,8 @@
  Install this package if you wish to develop your own programs using the
  V8 JavaScript Engine
 
-Package: libv8-2.2.24
-Architecture: i386 amd64 armel mipsel
+Package: libv8-2.5.9.9
+Architecture: i386 amd64 armel
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: V8 JavaScript Engine
  V8 is Google's open source, high performance JavaScript engine. It is written
@@ -34,9 +34,9 @@
 Package: libv8-dbg
 Priority: extra
 Section: debug
-Architecture: i386 amd64 armel mipsel
-Depends: libv8-2.2.24 (= ${binary:Version}), ${misc:Depends}
-Description: Development symbols for the V8 JavaScript Engine
+Architecture: i386 amd64 armel
+Depends: libv8-2.5.9.9 (= ${binary:Version}), ${misc:Depends}
+Description: Debugging symbols for the V8 JavaScript Engine
  V8 is Google's open source, high performance JavaScript engine. It is written
  in C++ and is used in Google Chrome, Google's open source browser.
  .

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/scons.mk

SONAME			:= 2.5.9.9

DEB_DH_MAKESHLIBS_ARGS := -- -c4

CXXFLAGS += -fno-strict-aliasing
CFLAGS += -fno-strict-aliasing
export CFLAGS
export CXXFLAGS

DEB_SCONS_OPTIONS          := library=shared soname=on shlibtype=hidden
DEB_SCONS_BUILD_TARGET     := library
# policy 4.9.1
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_BUILD_OPTIONS    := sample=shell
	DEB_SCONS_BUILD_TARGET     += sample cctests
endif
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	DEB_SCONS_BUILD_OPTIONS += -j$(NUMJOBS)
endif
DEB_SCONS_INSTALL_OPTIONS  := $(DEB_SCONS_OPTIONS) DESTDIR=$(DEB_DESTDIR)

clean::
	rm -f tools/*.pyc libv8-$(SONAME).so
	rm -rf obj
	rm -f test/*/*.pyc
	rm -f shell

common-post-build-impl::
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	LD_PRELOAD=$(CURDIR)/libv8-$(SONAME).so $(CURDIR)/tools/test.py --no-build cctest mjsunit message
endif

common-install-impl::
	cd debian/tmp/usr/lib/ ; \
	mv libv8-$(SONAME)*.so libv8.so.$(SONAME) ; \
	ln -s -T libv8.so.$(SONAME) libv8.so
